Attribute VB_Name = "modPCX"
'PCX Image Viewer for Visual Basic 6.0
'
'Copyright 2003 by Dmitry Brant, All Rights Reserved.

'Version 1.1, Last modified 04-27-2000
'
'me@dmitrybrant.com
'
'http://www.dmitrybrant.com


'This program fully supports the PCX format.

'Feel free to make improvements or optimizations to the program.
'If you do, please tell me or show me what you have done.

'This program is FREEWARE. Use freely, but give me credit
'where credit is due. (this program is NOT in the
'public domain). If you will use this source code in
'your software, the copyright notice stated above
'must be included in your source code and/or in the
'Help/About box of your program.

'The SOURCE CODE of this program, or portions of it, may not
'be redistributed, either by itself or in a compilation
'package, without express authorization from the author.

'ALL PRODUCT NAMES MENTIONED IN THIS SOFTWARE ARE TRADEMARKS
'OR REGISTERED TRADEMARKS OF THEIR RESPECTIVE OWNERS.

'THIS SOFTWARE IS DISTRIBUTED "AS IS". THE SOFTWARE IS
'DISTRIBUTED WITH NO WARRANTY, EIHER EXPRESSED
'OR IMPLIED, INCLUDING, BY WAY OF EXAMPLE THE IMPLIED
'WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
'PURPOSE. THE AUTHOR WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES,
'LOSS OF PROFITS OR ANY OTHER KIND OF LOSS RESULTING FROM THE
'USE OR MISUSE OF THIS SOFTWARE.

Option Explicit
DefInt A-Z

Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Public Sub DoPCX(FName As String, FObject As Object)
    Dim PcxVersion As Integer, FWidth As Integer, FHeight As Integer
    Dim ScreenSize As String * 8, BytesPerLine As Integer
    Dim i As Byte, j As Byte, Bpp As Integer, theHdc As Long
    Dim n As Integer, m As Integer
    Dim x As Integer, y As Integer, r As Integer, g As Integer, b As Integer
    Dim CPlanes As Integer
    Dim scan1 As String, scan2 As String, scan3 As String
    
    On Error GoTo ErrorTrap0
    
    Open FName For Binary As #1
    
    theHdc = FObject.hdc
    
    If GetByte <> 10 Then       'Get Marker
       Close #1
       MsgBox "Invalid PCX File.", vbCritical, "Error"
       Exit Sub
    End If
    
    If GetByte <> 5 Then        'Get Version
       Close #1
       MsgBox "We only support PCX Version 5.", vbCritical, "Error"
       Exit Sub
    End If
    
    If GetByte <> 1 Then        '1 = Run Length Compression
       Close #1
       MsgBox "Invalid compression byte. File may be corrupted.", vbCritical, "Error"
       Exit Sub
    End If
    
    Bpp = GetByte
    If Bpp <> 8 Then      'Get Bpp
       Close #1
       MsgBox "This program only supports 8-bit samples.", vbCritical, "Error"
       Exit Sub
    End If
    
    Get #1, , n
    Get #1, , m
    Get #1, , x
    Get #1, , y
    
    Get #1, , FWidth
    Get #1, , FHeight
    
    Seek #1, 66
    CPlanes = GetByte
    Get #1, , BytesPerLine
    
    If BytesPerLine = 0 Then
       BytesPerLine = x - n + 1
    End If
    FHeight = y - m + 1
    FWidth = x - n + 1
    
    If CPlanes = 1 Then
        ReDim Palette(0 To 255) As Long
        Seek #1, LOF(1) - 767
        For n = 0 To 255
            Palette(n) = RGB(GetByte, GetByte, GetByte)
        Next n
    End If
    
    Seek #1, 129
    x = 0: y = 0
    
    If CPlanes = 1 Then
        Do
            Get #1, , i
            If i > 191 Then
                Get #1, , j
                FObject.Line (x, y)-Step(i - 192, 0), Palette(j)
                x = x + i - 192
            Else
                j = i
                SetPixel theHdc, x, y, Palette(i)
                x = x + 1
            End If
            If x >= BytesPerLine Then
                x = 0: y = y + 1
                If y Mod 16 = 0 Then FObject.Refresh: DoEvents
            End If
        Loop Until y >= FHeight
        Erase Palette
    ElseIf CPlanes = 3 Then
        ReDim ScanlineR(0 To BytesPerLine - 1) As Byte
        ReDim ScanlineG(0 To BytesPerLine - 1) As Byte
        ReDim ScanlineB(0 To BytesPerLine - 1) As Byte
        For y = 0 To FHeight - 1
            n = 0
            Do
                'get RGB scanline
                Get #1, , i
                
                If i > 192 Then
                    Get #1, , j
                    For m = 1 To i - 192
                        If n >= BytesPerLine * 2 Then
                            ScanlineB(n - BytesPerLine * 2) = j
                        ElseIf n >= BytesPerLine Then
                            ScanlineG(n - BytesPerLine) = j
                        Else
                            ScanlineR(n) = j
                        End If
                        n = n + 1
                    Next m
                ElseIf i < 192 Then
                    If n >= BytesPerLine * 2 Then
                        ScanlineB(n - BytesPerLine * 2) = i
                    ElseIf n >= BytesPerLine Then
                        ScanlineG(n - BytesPerLine) = i
                    Else
                        ScanlineR(n) = i
                    End If
                    n = n + 1
                End If
                If n >= BytesPerLine * 3 Then n = 0: Exit Do
            Loop
    
            For n = 0 To FWidth - 1
                r = ScanlineR(n)
                g = ScanlineG(n)
                b = ScanlineB(n)
                SetPixel theHdc, n, y, RGB(r, g, b)
            Next n
            If y Mod 16 = 0 Then FObject.Refresh: DoEvents
        Next y
        Erase ScanlineR
        Erase ScanlineG
        Erase ScanlineB
    End If
    Close #1
    Exit Sub
    
ErrorTrap0:
    Close #1
    MsgBox "There was an error reading the file:" + vbCrLf + Error$, vbCrLf, "Error"
End Sub

Function GetByte() As Integer
    Dim a As Byte
    Get #1, , a
    GetByte = a
End Function
